import { AxiosInstance, Method, AxiosRequestConfig } from 'axios';
import type { Errors } from '..';
export interface ParametersType {
    [key: string]: any;
}
declare class BaseProxy {
    errors: Errors;
    parameters: any | any[];
    readonly endpoint: string;
    static $http: AxiosInstance | undefined;
    static $errorsKeyName: string;
    constructor(endpoint: string, parameters?: any | any[]);
    get $http(): AxiosInstance;
    get $errorsKeyName(): string;
    all(): Promise<any>;
    find(id: number | string): Promise<any>;
    post(payload: any, config?: AxiosRequestConfig): Promise<any>;
    store(payload: any, config?: AxiosRequestConfig): Promise<any>;
    put(id: string | number, payload: any): Promise<any>;
    putWithFile(id: string | number, payload: any, config?: AxiosRequestConfig): Promise<any>;
    patch(id: string | number, payload: any): Promise<any>;
    delete(id: string | number): Promise<any>;
    submit(requestType: Method, url: string, form?: any, config?: AxiosRequestConfig): Promise<any>;
    private __getParameterString;
    private static __validateRequestType;
    private __hasFiles;
    private __hasFilesDeep;
    setParameters(parameters: ParametersType): this;
    setParameter(parameter: string, value?: any): this;
    removeParameters(parameters?: any[]): this;
    removeParameter(parameter: any): this;
    onFail(errors: ParametersType): void;
    beforeSubmit(): void;
    onSuccess(): void;
}
export default BaseProxy;
